#include <bits/stdc++.h>
using namespace std;
int N, Q;
int PS[30][500001];
int main()
{
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  cin >> N >> Q;
  int x;
  for(int i = 1; i <= N; i++)
  {
    cin >> x;
    for(int j = 0; j < 30; j++) PS[j][i] = PS[j][i - 1];
    PS[__lg(x)][i]++;
  }
  int l, r;
  while(Q--)
  {
    cin >> l >> r;
    int sol = 0;
    for(int j = 0; j < 30; j++) sol = max(PS[j][r] - PS[j][l - 1], sol);
    cout << sol << '\n';
  }

  return 0;
}